From: Alexey Budankov <alexey.budankov@linux.intel.com>
To: Arnaldo Carvalho de Melo <acme@kernel.org>, Jiri Olsa <jolsa@redhat.com>
Cc: Namhyung Kim <namhyung@kernel.org>,
Alexander Shishkin <alexander.shishkin@linux.intel.com>,
Peter Zijlstra <peterz@infradead.org>,
Ingo Molnar <mingo@redhat.com>, Andi Kleen <ak@linux.intel.com>,
linux-kernel <linux-kernel@vger.kernel.org>
Subject: [PATCH v2 07/11] perf docs: extend stat mode docs with info on --ctl-fd[-ack] options
Date: Wed, 6 May 2020 21:22:55 +0300 [thread overview]
Message-ID: <fb7c1fb9-2f6b-eb4b-d256-51253b29b4ac@linux.intel.com> (raw)
In-Reply-To: <d582cc3d-2302-c7e2-70d3-bc7ab6f628c3@linux.intel.com>
Extend perf-stat.txt file with --ctl-fd[-ack] options description.
Document possible usage model introduced by --ctl-fd[-ack] options
by providing example bash shell script.
Signed-off-by: Alexey Budankov <alexey.budankov@linux.intel.com>
---
tools/perf/Documentation/perf-stat.txt | 40 ++++++++++++++++++++++++++
1 file changed, 40 insertions(+)
diff --git a/tools/perf/Documentation/perf-stat.txt b/tools/perf/Documentation/perf-stat.txt
index 3fb5028aef08..19ed53e08294 100644
--- a/tools/perf/Documentation/perf-stat.txt
+++ b/tools/perf/Documentation/perf-stat.txt
@@ -164,6 +164,46 @@ with it. --append may be used here. Examples:
3>results perf stat --log-fd 3 -- $cmd
3>>results perf stat --log-fd 3 --append -- $cmd
+--ctl-fd::
+--ctl-fd-ack::
+
+Listen on ctl-fd descriptor for command to control measurement ('e': enable events,
+'d': disable events). Optionally send control command completion ('a') to fd-ack
+descriptor to synchronize with the controlling process. Example of bash shell script
+to enable and disable events during measurements:
+
+#!/bin/bash
+
+ctl_dir=/tmp/
+
+ctl_fifo=${ctl_dir}perf_ctl.fifo
+test -p ${ctl_fifo} && unlink ${ctl_fifo}
+mkfifo ${ctl_fifo}
+exec {ctl_fd}<>${ctl_fifo}
+
+ctl_ack_fifo=${ctl_dir}perf_ctl_ack.fifo
+test -p ${ctl_ack_fifo} && unlink ${ctl_ack_fifo}
+mkfifo ${ctl_ack_fifo}
+exec {ctl_fd_ack}<>${ctl_ack_fifo}
+
+perf stat -D -1 -e cpu-cycles -a -I 1000 \
+ --ctl-fd ${ctl_fd} --ctl-fd-ack ${ctl_fd_ack} \
+ -- sleep 30 &
+perf_pid=$!
+
+sleep 5 && echo 'e' >&${ctl_fd} && read -u ${ctl_fd_ack} e1 && echo "enabled(${e1})"
+sleep 10 && echo 'd' >&${ctl_fd} && read -u ${ctl_fd_ack} d1 && echo "disabled(${d1})"
+
+exec {ctl_fd_ack}>&-
+unlink ${ctl_ack_fifo}
+
+exec {ctl_fd}>&-
+unlink ${ctl_fifo}
+
+wait -n ${perf_pid}
+exit $?
+
+
--pre::
--post::
Pre and post measurement hooks, e.g.:
--
2.24.1
next prev parent reply other threads:[~2020-05-06 18:23 UTC|newest]
Thread overview: 25+ messages / expand[flat|nested] mbox.gz Atom feed top
2020-05-06 17:16 [PATCH v2 00/11] perf: support enable and disable commands in stat and record modes Alexey Budankov
2020-05-06 18:18 ` [PATCH v2 01/11] perf evlist: introduce control file descriptors Alexey Budankov
2020-05-06 18:19 ` [PATCH v2 02/11] perf evlist: implement control command handling functions Alexey Budankov
2020-05-06 20:21 ` Arnaldo Carvalho de Melo
2020-05-07 8:32 ` Alexey Budankov
2020-05-07 17:01 ` Arnaldo Carvalho de Melo
2020-05-07 17:51 ` Alexey Budankov
2020-05-06 18:20 ` [PATCH v2 03/11] perf stat: factor out event handling loop into a function Alexey Budankov
2020-05-06 18:20 ` [PATCH v2 04/11] perf stat: extend -D,--delay option with -1 value Alexey Budankov
2020-05-06 20:12 ` Arnaldo Carvalho de Melo
2020-05-07 8:34 ` Alexey Budankov
2020-05-06 18:21 ` [PATCH v2 05/11] perf stat: implement control commands handling Alexey Budankov
2020-05-06 18:22 ` [PATCH v2 06/11] perf stat: introduce --ctl-fd[-ack] options Alexey Budankov
2020-05-06 18:22 ` Alexey Budankov [this message]
2020-05-06 20:22 ` [PATCH v2 07/11] perf docs: extend stat mode docs with info on " Arnaldo Carvalho de Melo
2020-05-07 8:35 ` Alexey Budankov
2020-05-06 18:28 ` [PATCH v2 08/11] perf record: extend -D,--delay option with -1 value Alexey Budankov
2020-05-06 18:29 ` [PATCH v2 09/11] perf record: implement control commands handling Alexey Budankov
2020-05-06 20:23 ` Arnaldo Carvalho de Melo
2020-05-07 8:58 ` Alexey Budankov
2020-05-07 17:02 ` Arnaldo Carvalho de Melo
2020-05-06 18:29 ` [PATCH v2 10/11] perf record: introduce --ctl-fd[-ack] options Alexey Budankov
2020-05-06 18:30 ` [PATCH v2 11/11] perf docs: extend record mode docs with info on " Alexey Budankov
2020-05-06 20:27 ` Arnaldo Carvalho de Melo
2020-05-07 8:36 ` Alexey Budankov
Reply instructions:
You may reply publicly to this message via plain-text email
using any one of the following methods:
* Save the following mbox file, import it into your mail client,
and reply-to-all from there: mbox
Avoid top-posting and favor interleaved quoting:
https://en.wikipedia.org/wiki/Posting_style#Interleaved_style
* Reply using the --to, --cc, and --in-reply-to
switches of git-send-email(1):
git send-email \
--in-reply-to=fb7c1fb9-2f6b-eb4b-d256-51253b29b4ac@linux.intel.com \
--to=alexey.budankov@linux.intel.com \
--cc=acme@kernel.org \
--cc=ak@linux.intel.com \
--cc=alexander.shishkin@linux.intel.com \
--cc=jolsa@redhat.com \
--cc=linux-kernel@vger.kernel.org \
--cc=mingo@redhat.com \
--cc=namhyung@kernel.org \
--cc=peterz@infradead.org \
/path/to/YOUR_REPLY
https://kernel.org/pub/software/scm/git/docs/git-send-email.html
* If your mail client supports setting the In-Reply-To header
via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line
before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox